import * as i0 from '@angular/core';
import { Component, Inject, Injectable, NgModule } from '@angular/core';
import * as i2 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i1 from '@angular/material/snack-bar';
import { MAT_SNACK_BAR_DATA, MatSnackBarModule, MAT_SNACK_BAR_DEFAULT_OPTIONS } from '@angular/material/snack-bar';
import * as i3 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';

class IHNotificationComponent {
    /**
     * Creates an instance of IHNotificationComponent.
     * @author IDNAN.HAIDER
     * @param snackBarRef
     * @param notificationData
     */
    constructor(snackBarRef, notificationData) {
        this.snackBarRef = snackBarRef;
        this.notificationData = notificationData;
    }
    /**
     * This method is to close or invoke call back
     *
     */
    customAction() {
        if (this.notificationData.closeable) {
            this.snackBarRef.dismiss();
        }
        else if (this.notificationData.action) {
            this.notificationData.action.cb();
        }
    }
}
IHNotificationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationComponent, deps: [{ token: i1.MatSnackBarRef }, { token: MAT_SNACK_BAR_DATA }], target: i0.ɵɵFactoryTarget.Component });
IHNotificationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: IHNotificationComponent, selector: "ih-ng-notification", ngImport: i0, template: "<div class=\"row-space-between\">\r\n  <mat-icon class=\"icon-notification\">{{ notificationData.icon }}</mat-icon>\r\n  <div class=\"msg\">\r\n    <!-- TODO Heading here HTMLsupport available -->\r\n    <!-- <div\r\n        *ngIf=\"notificationData.heading\"\r\n        [innerHTML]=\"notificationData.heading\"\r\n        ></div> -->\r\n\r\n    <!-- TODO Translation will be added in next version -->\r\n    <!-- Message here HTMLsupport available -->\r\n    <div [innerHTML]=\"notificationData.message\"></div>\r\n  </div>\r\n\r\n  <mat-icon\r\n    matTooltip=\"{{ notificationData.action?.tooltip }}\"\r\n    class=\"icon-cursor-pointer\"\r\n    (click)=\"customAction()\"\r\n  >\r\n    {{\r\n      notificationData.closeable ? \"close\" : notificationData.action?.icon\r\n    }}</mat-icon\r\n  >\r\n</div>\r\n", styles: ["mat-icon{width:1.6rem;height:1.6rem;font-size:1.6rem}.icon-cursor-pointer{cursor:pointer}.icon-cursor-pointer:hover{transform:scale(1.5)}::ng-deep .mat-mdc-snack-bar-container.success-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#00a800!important;color:#fff!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.error-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#d70b00!important;color:#fff!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.warning-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#ec8c33!important;color:#000!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.info-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#8adef8!important;color:#000!important;min-height:2.4rem}.msg{display:flex;flex-direction:column;font-size:1rem;margin:0 .5rem;width:80%}.row-space-between{display:flex;flex-direction:row;justify-content:space-between;align-items:center}\n"], dependencies: [{ kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ih-ng-notification', template: "<div class=\"row-space-between\">\r\n  <mat-icon class=\"icon-notification\">{{ notificationData.icon }}</mat-icon>\r\n  <div class=\"msg\">\r\n    <!-- TODO Heading here HTMLsupport available -->\r\n    <!-- <div\r\n        *ngIf=\"notificationData.heading\"\r\n        [innerHTML]=\"notificationData.heading\"\r\n        ></div> -->\r\n\r\n    <!-- TODO Translation will be added in next version -->\r\n    <!-- Message here HTMLsupport available -->\r\n    <div [innerHTML]=\"notificationData.message\"></div>\r\n  </div>\r\n\r\n  <mat-icon\r\n    matTooltip=\"{{ notificationData.action?.tooltip }}\"\r\n    class=\"icon-cursor-pointer\"\r\n    (click)=\"customAction()\"\r\n  >\r\n    {{\r\n      notificationData.closeable ? \"close\" : notificationData.action?.icon\r\n    }}</mat-icon\r\n  >\r\n</div>\r\n", styles: ["mat-icon{width:1.6rem;height:1.6rem;font-size:1.6rem}.icon-cursor-pointer{cursor:pointer}.icon-cursor-pointer:hover{transform:scale(1.5)}::ng-deep .mat-mdc-snack-bar-container.success-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#00a800!important;color:#fff!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.error-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#d70b00!important;color:#fff!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.warning-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#ec8c33!important;color:#000!important;min-height:2.4rem}::ng-deep .mat-mdc-snack-bar-container.info-notification{--mdc-snackbar-container-color: $bg-color !important;--mat-mdc-snack-bar-button-color: #fff;--mdc-snackbar-supporting-text-color: get-text-color($bg-color) !important;background-color:#8adef8!important;color:#000!important;min-height:2.4rem}.msg{display:flex;flex-direction:column;font-size:1rem;margin:0 .5rem;width:80%}.row-space-between{display:flex;flex-direction:row;justify-content:space-between;align-items:center}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.MatSnackBarRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_SNACK_BAR_DATA]
                }] }]; } });

class IHNotificationService {
    /**
     * Creates an instance of IHNotificationService.
     * @author IDNAN.HAIDER
     * @param snackBar
     */
    constructor(snackBar) {
        this.snackBar = snackBar;
        this.icons = {
            error: 'error',
            warning: 'warning',
            success: 'check_circle',
            info: 'info',
        };
    }
    /**
     * @description This method is to show notification of error type
     * @author IDNAN.HAIDER
     * @param message
     * @param [heading]
     * @param [closeable=false]
     * @param [config={}]
     */
    error(message, heading, closeable = false, config = {}) {
        this.show(message, 'error', heading, closeable, config);
    }
    /**
     * @description This method is to show notification of success type
     * @author IDNAN.HAIDER
     * @param message
     * @param [heading]
     * @param [closeable=false]
     * @param [config={}]
     */
    success(message, heading, closeable = false, config = {}) {
        this.show(message, 'success', heading, closeable, config);
    }
    /**
     * @description This method is to show notification of warning type
     * @author IDNAN.HAIDER
     * @param message
     * @param [heading]
     * @param [closeable=false]
     * @param [config={}]
     */
    warning(message, heading, closeable = false, config = {}) {
        this.show(message, 'warning', heading, closeable, config);
    }
    /**
     * @description This method is to show notification of info type
     * @author IDNAN.HAIDER
     * @param message
     * @param [heading]
     * @param [closeable=false]
     * @param [config={}]
     */
    info(message, heading, closeable = false, config = {}) {
        this.show(message, 'info', heading, closeable, config);
    }
    /**
     * @description This method is to show notification of given type
     * @author IDNAN.HAIDER
     * @private
     * @param message
     * @param type
     * @param [heading]
     * @param [closeable=false]
     * @param [config={}]
     */
    show(message, type, heading, closeable = false, config = {}) {
        this.snackBar.openFromComponent(IHNotificationComponent, {
            ...this.getNotificationConfig(message, type, heading, closeable),
            ...config,
        });
    }
    /**
     * @description This method is to show notification of given type with custom call back support
     * Only mat-icon name is supported
     * @author IDNAN.HAIDER
     * @param message
     * @param type
     * @param action
     * @param [heading]
     * @param [config={}]
     */
    showNotificationWithCustomActionIcon(message, type, action, heading, config = {}) {
        this.snackBar.openFromComponent(IHNotificationComponent, {
            ...this.getNotificationConfig(message, type, heading, false, action),
            ...config,
        });
    }
    /**
     * @description This method is to get configurational data for snackbar custom component
     * @author IDNAN.HAIDER
     * @private
     * @param message
     * @param messageType
     * @param [heading]
     * @param [closeButton=true]
     * @param [action]
     * @return {*}
     */
    getNotificationConfig(message, messageType, heading, closeButton = true, action) {
        const notificationData = {
            data: {
                heading,
                message,
                closeable: closeButton,
                icon: this.icons[messageType],
            },
            panelClass: `${messageType}-notification`,
            direction: 'ltr', // TODO will add directional support,
        };
        if (action) {
            notificationData.data['action'] = action;
        }
        return notificationData;
    }
}
IHNotificationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationService, deps: [{ token: i1.MatSnackBar }], target: i0.ɵɵFactoryTarget.Injectable });
IHNotificationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.MatSnackBar }]; } });

/**
 * @type {*}
 */
const module = [MatSnackBarModule, MatIconModule, MatTooltipModule];
// Default Snackbar configuration
const DEFAULT_SNACK_BAR_CONFIG = {
    duration: 6000,
    horizontalPosition: 'right',
    verticalPosition: 'top',
};
class IHNotificationModule {
}
IHNotificationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
IHNotificationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationModule, declarations: [IHNotificationComponent], imports: [MatSnackBarModule, MatIconModule, MatTooltipModule], exports: [IHNotificationComponent] });
IHNotificationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationModule, providers: [
        {
            provide: MAT_SNACK_BAR_DEFAULT_OPTIONS,
            useValue: DEFAULT_SNACK_BAR_CONFIG,
        },
        IHNotificationService,
    ], imports: [module] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: IHNotificationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [IHNotificationComponent],
                    imports: [...module],
                    providers: [
                        {
                            provide: MAT_SNACK_BAR_DEFAULT_OPTIONS,
                            useValue: DEFAULT_SNACK_BAR_CONFIG,
                        },
                        IHNotificationService,
                    ],
                    exports: [IHNotificationComponent],
                }]
        }] });

/*
 * Public API Surface of ih-ng-notification
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DEFAULT_SNACK_BAR_CONFIG, IHNotificationComponent, IHNotificationModule, IHNotificationService };
//# sourceMappingURL=ih-ng-notification.mjs.map
